

/*  Base Class.c  $ 31/03/98 MT $  */


#include "exec/types.h"
#include "exec/memory.h"
#include "utility/tagitem.h"
#include "graphics/gfxbase.h"
#include "intuition/intuition.h"
#include "intuition/classes.h"
#include "intuition/classusr.h"
#include "intuition/imageclass.h"
#include "utility/hooks.h"
#include "proto/exec.h"
#include "proto/graphics.h"
#include "proto/intuition.h"
#include "proto/utility.h"
#include "boopsisupp.h"
#include "librarybase.h"


#define CLASSID       "baseclass"
#define SUPERCLASSID  "rootclass"
#define WANTED_LIBVER 39


/* Local function prototypes */

ULONG __saveds __asm ClassDispatcher(register __a0 Class *cl, register __a2 Object *obj, register __a1 Msg msg);


/* The dispatcher */

ULONG __saveds __asm ClassDispatcher(register __a0 Class *cl, register __a2 Object *obj, register __a1 Msg msg)
{
   ULONG result;

   switch (msg->MethodID)
   {
      default:
         result = DoSuperMethodA(cl,obj,msg);
   }

   return (result);
}

/* The class constructor function */

Class * __saveds __asm OpenLibraryClass(void)
{
   Class *class;

   if (class = MakeClass(CLASSID,SUPERCLASSID,NULL,0,0))
   {
      class->cl_Dispatcher.h_Entry = (HOOKFUNC)ClassDispatcher;
      AddClass(class);
      return (class);
   }

   return (NULL);
}

/* The class destructor function */

ULONG __saveds __asm CloseLibraryClass(register __a0 Class *class)
{
   ULONG result;

   result = FreeClass(class);

   return (result);
}


