

/*  Fast Layout Library Test  $ 30/09/94 MT $  */


#include "exec/types.h"
#include "graphics/gfx.h"
#include "graphics/rastport.h"
#include "intuition/intuition.h"
#include "intuition/gadgetclass.h"
#include "libraries/gadtools.h"
#include "utility/tagitem.h"
#include "proto/exec.h"
#include "proto/graphics.h"
#include "proto/intuition.h"
#include "proto/gadtools.h"
#include "libraries/fastlayout.h"
#include "clib/fastlayout_protos.h"

#ifdef SHARED
#include "pragmas/fastlayout_pragmas.h"
struct Library *FastLayoutBase;
#else
#include "proto/utility.h"
#endif


struct ScanData
{
   struct Window *Window;
   APTR Layout;
};


static UBYTE *MXLabels[] = { "Prima opzione", "Seconda opzione", "Terza opzione", "Quarta opzione", "Quinta opzione",
                             "Sesta opzione", "Settima opzione", "Ottava opzione", "Nona opzione", "Decima opzione",
                              NULL };


struct Gadget *CreaGadgets(struct Window *win, APTR vi, struct List *lvlist, APTR layout, APTR root)
{
   struct Gadget *gad, *glist;
   struct NewGadget ng;
   static UBYTE *labels[] = { "Palette a 4 bit", "Palette a 32 bit", NULL };

   ng.ng_GadgetText = "File di input...";
   ng.ng_TextAttr = NULL;
   ng.ng_GadgetID = 1;
   ng.ng_Flags = PLACETEXT_IN;
   ng.ng_VisualInfo = vi;

   gad = CreateContext(&glist);

   gad = CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = "File di output...";
   ng.ng_GadgetID = 3;

   gad = CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = NULL;
   ng.ng_GadgetID = 2;

   gad = CreateGadgetL(layout,root,STRING_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetID = 4;

   gad = CreateGadgetL(layout,root,STRING_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = "Tipo di conversione";
   ng.ng_Flags |= NG_HIGHLABEL;
   ng.ng_GadgetID = 5;

   gad = CreateGadgetL(layout,root,TEXT_KIND,gad,&ng,GTTX_Border,FALSE,TAG_END);

   // ListView

   ng.ng_GadgetText = NULL;

   ng.ng_Flags &= ~NG_HIGHLABEL;
   ng.ng_GadgetID = 6;

   ModifyLabelList(lvlist,MXLabels,LL_STRING,-1);

   gad = CreateGadgetL(layout,root,LISTVIEW_KIND,gad,&ng,GTLV_Labels,lvlist,GTLV_ShowSelected,NULL,TAG_END);

   ng.ng_GadgetText = "Modo";
   ng.ng_Flags = PLACETEXT_LEFT;
   ng.ng_GadgetID = 7;

   gad = CreateGadgetL(layout,root,CYCLE_KIND,gad,&ng,GTCY_Labels,labels,TAG_END);

   ng.ng_GadgetText = "Mostra l'immagine";
   ng.ng_Flags = PLACETEXT_IN;
   ng.ng_GadgetID = 8;

   gad = CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = "Opzioni avanzate...";
   ng.ng_GadgetID = 9;

   gad = CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = "Esamina il file...";
   ng.ng_GadgetID = 10;

   gad = CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = "Converti";
   ng.ng_GadgetID = 11;

   gad = CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   ng.ng_GadgetText = "Esci";
   ng.ng_GadgetID = 12;

   (void)CreateGadgetL(layout,root,BUTTON_KIND,gad,&ng,TAG_END);

   return (glist);
}

ULONG __asm __saveds DisegnaItem(register __a0 APTR li, register __a1 APTR scandata)
{
   struct RastPort *rport = ((struct ScanData *)scandata)->Window->RPort;
   struct Layout *layout = ((struct ScanData *)scandata)->Layout;
   struct IBox ibox;
   ULONG btype, bx, by;

   GetLayoutItemAttrs(layout,li,FL_ItemSpec,&ibox,FL_BorderType,&btype,TAG_END);

   switch (btype)
   {
      case BT_SPACE:
         bx = 6; by = 4; break;

      case BT_RAISED:
      case BT_RECESSED:
         bx = 8; by = 5; break;

      case BT_LINE:
         bx = 10; by = 6; break;

      default:
         bx = by = 0;
   }

   Move(rport,ibox.Left - bx,ibox.Top - by);
   Draw(rport,ibox.Left + ibox.Width - 1 + bx,ibox.Top - by);
   Draw(rport,ibox.Left + ibox.Width - 1 + bx,ibox.Top + ibox.Height - 1 + by);
   Draw(rport,ibox.Left - bx,ibox.Top + ibox.Height - 1 + by);
   Draw(rport,ibox.Left - bx,ibox.Top - by);

   if (btype)
   {
      SetAPen(rport,2);
      Move(rport,ibox.Left,ibox.Top);
      Draw(rport,ibox.Left + ibox.Width - 1,ibox.Top);
      Draw(rport,ibox.Left + ibox.Width - 1,ibox.Top + ibox.Height - 1);
      Draw(rport,ibox.Left,ibox.Top + ibox.Height - 1);
      Draw(rport,ibox.Left,ibox.Top);
      SetAPen(rport,1);
   }

   return (0L);
}

void DisegnaLayout(struct Window *win, APTR layout, APTR firstitem)
{
   struct ScanData sd;

   sd.Window = win;
   sd.Layout = layout;

   SetAPen(win->RPort,1);
   ScanLayoutItemTree(firstitem,SCAN_NODEFIRST,DisegnaItem,&sd);
}

void ProvaLayout(APTR layout, APTR firstitem)
{
   struct Screen *scr;
   struct Window *win;
   struct Gadget *glist;
   struct IntuiMessage *im, imsave;
   struct List *lvlist;
   BOOL exit = FALSE, changed = FALSE;
   BOOL frame = FALSE, gui = TRUE, refresh = FALSE;
   APTR vi;
   UBYTE title[] = "Prova layout";
   UWORD scrfontheight = 18, key = '\0';
   ULONG scrwidth = 640, scrheight = 400;
   ULONG width = 640, height = 400, minwidth, minheight;
   ULONG idcmpflags = IDCMP_CLOSEWINDOW|IDCMP_NEWSIZE|LISTVIEWIDCMP|IDCMP_VANILLAKEY;

   if (!layout) return;

   if (scr = LockPubScreen(NULL))
   {
      scrwidth = scr->Width;
      scrheight = scr->Height;
      scrfontheight = scr->Font->ta_YSize;
      UnlockPubScreen(NULL,scr);
   }

   minwidth = MinimumWidth(layout,firstitem) + 22;
   minheight = MinimumHeight(layout,firstitem) + 5 + scrfontheight;

   if (width < minwidth) width = minwidth;
   if (height < minheight) height = minheight;

   if (win = OpenWindowTags(NULL,WA_Left,(scrwidth - width) / 2,
                                 WA_Top,(scrheight - height) / 2,
                                 WA_Width,width,WA_Height,height,
                                 WA_MinWidth,minwidth,WA_MinHeight,minheight,
                                 WA_MaxWidth,~0,WA_MaxHeight,~0,
                                 WA_Activate,TRUE,WA_DepthGadget,TRUE,
                                 WA_SizeGadget,TRUE,WA_CloseGadget,TRUE,
                                 WA_Title,(ULONG)title,WA_DragBar,TRUE,
                                 WA_IDCMP,idcmpflags,
                                 WA_SimpleRefresh,TRUE,
                                 TAG_END))
   {
      vi = GetVisualInfoA(win->WScreen,NULL);
      lvlist = CreateLabelList(NULL,LL_STRING,-1);

      (void)ComputeLayout(layout,firstitem,win->BorderLeft,win->BorderTop,win->Width - win->BorderRight - win->BorderLeft,win->Height - win->BorderTop - win->BorderBottom);

      glist = CreaGadgets(win,vi,lvlist,layout,firstitem);

      //DisegnaLayout(win,layout,firstitem);

      AddGList(win,glist,-1,-1,NULL);
      RefreshGList(glist,win,NULL,-1);
      GT_RefreshWindow(win,NULL);
      RefreshLayout(win,layout,firstitem);

      while (!exit)
      {
         Wait(1 << win->UserPort->mp_SigBit);

         while (im = GT_GetIMsg(win->UserPort))
         {
            imsave = *im;
            GT_ReplyIMsg(im);
            if (imsave.Class == IDCMP_NEWSIZE) changed = TRUE;
            if (imsave.Class == IDCMP_CLOSEWINDOW) exit = TRUE;
            if ((imsave.Class == IDCMP_GADGETUP) && (((struct Gadget *)(imsave.IAddress))->GadgetID == 12)) exit = TRUE;
            if (imsave.Class == IDCMP_VANILLAKEY) key = imsave.Code;
            if (imsave.Class == IDCMP_REFRESHWINDOW) refresh = TRUE;
         }

         if (refresh)
         {
            GT_BeginRefresh(win);
            GT_EndRefresh(win,TRUE);
            refresh = FALSE;
         }

         if (key)
         {
            switch (toupper(key))
            {
               case 'F':
                  frame = !frame;
                  changed = TRUE;
                  break;

               case 'G':
                  gui = !gui;
                  changed = TRUE;
                  break;
            }

            key = '\0';
         }

         if (changed)
         {
            changed = FALSE;

            RemoveGList(win,glist,-1);
            RefreshWindowFrame(win);
            FreeGadgets(glist);

            EraseRect(win->RPort,win->BorderLeft,win->BorderTop,win->Width - win->BorderRight - 1,win->Height - win->BorderBottom - 1);
            (void)ComputeLayout(layout,firstitem,win->BorderLeft,win->BorderTop,win->Width - win->BorderRight - win->BorderLeft,win->Height - win->BorderTop - win->BorderBottom);
            glist = CreaGadgets(win,vi,lvlist,layout,firstitem);

            if (frame) DisegnaLayout(win,layout,firstitem);

            AddGList(win,glist,-1,-1,NULL);

            if (gui)
            {
               RefreshGList(glist,win,NULL,-1);
               GT_RefreshWindow(win,NULL);
               RefreshLayout(win,layout,firstitem);
            }
         }
      }

      RemoveGList(win,glist,-1);
      FreeGadgets(glist);

      FreeLabelList(lvlist);
      FreeVisualInfo(vi);

      CloseWindow(win);
   }
}

/*
ULONG __saveds __asm  ControllaItem(register __a0 APTR item, register __a1 APTR layout)
{
   ULONG bordertype;

   GetLayoutItemAttrs(layout,item,FL_BorderType,&bordertype,TAG_END);
   printf("BorderType: %d\n",bordertype);
   return (0L);
}

void ControllaAlbero(APTR primoitem, APTR layout)
{
   ScanLayoutItemTree(primoitem,SCAN_NODEFIRST,ControllaItem,layout);
}
*/

LONG main(void)
{
   APTR first;
   APTR layout;
   struct TextAttr textattr = { "topaz.font", 8, 0, 0 }, *ta = &textattr;
   struct ListInfo lvinfo = { LISTVIEW_KIND, 0, 0, 16, 0 };
   struct ListInfo cyinfo = { CYCLE_KIND, PLACETEXT_LEFT, 0, 0, 0 };
   UBYTE *testo[] = { "File di input...", "File di output...",
                      "Mostra l'immagine", "Esamina il file...",
                      "Opzioni avanzate...", "Converti", "Esci",
                      "Tipo di conversione", "Modo" };
   UBYTE *cylabels[] = { "Palette a 4 bit", "Palette a 32 bit", NULL };

#ifdef SHARED
   if (!(FastLayoutBase = OpenLibrary("fastlayout.library",40))) exit(10L);
#else
   if (!(UtilityBase = OpenLibrary("utility.library",36))) exit(10L);
#endif

   if (!(GadToolsBase = OpenLibrary("gadtools.library",36)))
   {
#ifdef SHARED
      CloseLibrary(FastLayoutBase);
#else
      CloseLibrary(UtilityBase);
#endif

      exit(10L);
   }

   first = NewItem(IT_ZONE,0,LT_VERT,
           FL_RelSize,1,
           //FL_Justify,JT_LEFTTOP,
           FL_AutoSpace,3,
           FL_BorderType,BT_RAISED,
           FL_Item,NewItem(IT_ZONE,0,LT_HORIZ,
                           FL_AutoSpace,3,
                           FL_Item,NewItem(IT_GADGET,1,0,FL_GadgetText,&testo[0],FL_SizeGroup,1,TAG_END),
                           FL_Item,NewItem(IT_GADGET,2,0,FL_RelSize,1,TAG_END),
                           TAG_END),
           FL_Item,NewItem(IT_ZONE,0,LT_HORIZ,
                           FL_AutoSpace,3,
                           FL_Item,NewItem(IT_GADGET,3,0,FL_GadgetText,&testo[1],FL_SizeGroup,1,TAG_END),
                           FL_Item,NewItem(IT_GADGET,4,0,FL_RelSize,1,TAG_END),
                           TAG_END),
           FL_Item,NewItem(IT_ZONE,0,LT_HORIZ,
                           FL_RelSize,1,
                           FL_AutoSpace,3,
                           FL_Item,NewItem(IT_ZONE,0,LT_VERT,
                                           FL_RelSize,1,
                                           FL_AutoSpace,3,
                                           FL_BorderType,BT_LINE,
                                           FL_Item,NewItem(IT_GADGET,5,0,FL_GadgetText,&testo[7],TAG_END),
                                           FL_Item,NewItem(IT_GADGET,6,0,FL_RelSize,1,FL_ListInfo,&lvinfo,FL_Labels,MXLabels,TAG_END),
                                           FL_Item,NewItem(IT_GADGET,7,0,FL_GadgetText,&testo[8],FL_ListInfo,&cyinfo,FL_Labels,cylabels,TAG_END),
                                           TAG_END),
                           FL_Item,NewItem(IT_ZONE,0,LT_VERT,
                                           FL_RelSize,1,
                                           FL_BorderType,BT_RECESSED,
                                           TAG_END),
                           TAG_END),
           FL_Item,NewItem(IT_ZONE,0,LT_HORIZ,
                           FL_AutoSpace,3,
                           FL_Item,NewItem(IT_GADGET,8,0,FL_GadgetText,&testo[2],FL_SizeGroup,2,TAG_END),
                           FL_Item,NewItem(IT_GADGET,9,0,FL_GadgetText,&testo[4],TAG_END),
                           FL_Item,NewItem(IT_GADGET,10,0,FL_GadgetText,&testo[3],FL_SizeGroup,2,TAG_END),
                           TAG_END),
           FL_Item,NewItem(IT_ZONE,0,LT_HORIZ,
                           FL_AutoSpace,3,
                           FL_Item,NewItem(IT_GADGET,11,0,FL_GadgetText,&testo[5],FL_SizeGroup,3,TAG_END),
                           FL_Item,NewItem(IT_GADGET,12,0,FL_GadgetText,&testo[6],FL_SizeGroup,3,TAG_END),
                           TAG_END),
           TAG_END);

   layout = CreateLayout(LT_HORIZ,FL_TextAttr,ta,TAG_END);

   //ControllaAlbero(first,layout);

   printf("Dimensioni minime della finestra: %ld%ld\n",MinimumWidth(layout,first),MinimumHeight(layout,first));

   ProvaLayout(layout,first);

   FreeLayout(layout);

   CloseLibrary(GadToolsBase);

#ifdef SHARED
   CloseLibrary(FastLayoutBase);
#else
   CloseLibrary(UtilityBase);
#endif

   return (0L);
}

