

#ifndef CLIB_FASTLAYOUT_PROTOS_H
#define CLIB_FASTLAYOUT_PROTOS_H


/*  Fast Layout Library prototypes  $ 17/05/95 MT $  */


void FreeLayoutItems(APTR root);
void FreeLayout(APTR layout);
APTR CreateLayoutA(ULONG ltype, struct TagItem *taglist);
APTR CreateLayout(ULONG ltype, Tag tag1, ...);
APTR FindLayoutItem(APTR root, ULONG type, ULONG id);
void GetLayoutAttrsA(APTR layout, struct TagItem *taglist);
void GetLayoutAttrs(APTR layout, Tag tag1, ...);
APTR SetLayoutAttrsA(APTR layout, struct TagItem *taglist);
APTR SetLayoutAttrs(APTR layout, Tag tag1, ...);
void GetLayoutItemAttrsA(APTR layout, APTR litem, struct TagItem *taglist);
void GetLayoutItemAttrs(APTR layout, APTR litem, Tag tag1, ...);
APTR SetLayoutItemAttrsA(APTR layout, APTR litem, struct TagItem *taglist);
APTR SetLayoutItemAttrs(APTR layout, APTR litem, Tag tag1, ...);

APTR CreateLayoutItemA(ULONG type, ULONG id, ULONG ltype,
                       struct TagItem *taglist);

APTR CreateLayoutItem(ULONG type, ULONG id, ULONG ltype, Tag tag1, ...);
ULONG MinimumWidth(APTR layout, APTR root);
ULONG MinimumHeight(APTR layout, APTR root);
void RefreshLayout(struct Window *win, APTR layout, APTR root);
BOOL ComputeLayout(APTR layout,APTR root,ULONG left,ULONG top,ULONG width,ULONG height);
struct List *CreateLabelList(void *array, ULONG type, ULONG num);
BOOL ModifyLabelList(struct List *list, void *array, ULONG type, ULONG num);
void FreeLabelList(struct List *list);
APTR BuildLItemListA(ULONG includelists, struct TagItem *taglist);
APTR BuildLItemList(ULONG includelists, Tag tag1, ...);

ULONG ScanLayoutItemTree(APTR item, ULONG scantype,
                         ULONG (*function)(APTR,APTR), APTR userdata);

struct Gadget *CreateGadgetLA(APTR layout, APTR root, ULONG kind,
                              struct Gadget *gad, struct NewGadget *ng,
                              struct TagItem *taglist);

struct Gadget *CreateGadgetL(APTR layout, APTR root, ULONG kind,
                             struct Gadget *gad, struct NewGadget *ng,
                             Tag tag1, ...);


#endif

