

#ifndef FASTLAYOUT_PRIVATE_H
#define FASTLAYOUT_PRIVATE_H


/*  Fast Layout private definitions  $ 14/05/95 MT $  */


/* Size types (internal definitions) */

#define ST_FIXED    0   /* Internal */
#define ST_RELSPACE 1   /* Internal */
#define ST_RELSIZE  2   /* Internal, not implemented yet */
#define ST_RELTEXT  3   /* Internal */
#define ST_RELCONT  4   /* Internal */

/* Flags for the items (internal definitions) */

#define IF_JLEFTTOP     0x00000001  /* Internal */
#define IF_JRIGHTBOTTOM 0x00000002  /* Internal */
#define IF_JCENTER      0x00000003  /* Internal */
#define IF_AUTOSPACE    0x00000004  /* Internal */
#define IF_MINSIZE      0x00000008  /* Internal */
#define IF_ALIGNITEMS   0x00000010  /* Internal */

/* Default values of some parameters */

#define DEFAUTOSIZE    2  /* Default size of fixed auto spaces */
#define DEFMINSIZE    10  /* Default minimum size of items */
#define DEFGADGHDELTA 38  /* Default horizontal space added to gadgets */
#define DEFGADGVDELTA  6  /* Default vertical space added to gadgets */
#define DEFB1HSIZE     6  /* Default horizontal size for space borders */
#define DEFB1VSIZE     4  /* Default vertical size for space borders */
#define DEFB2HSIZE     8  /* Default horizontal size for raised borders */
#define DEFB2VSIZE     5  /* Default vertical size for raised borders */
#define DEFB3HSIZE    10  /* Default horizontal size for line borders */
#define DEFB3VSIZE     6  /* Default vertical size for line borders */
#define DEFBHSIZE      8  /* Default horizontal size for all borders */
#define DEFBVSIZE      5  /* Default vertical size for all borders */


/* Internal structures */

struct LayoutItem
{
   ULONG Left, Top;
   ULONG Width, Height;
   UWORD Type;
   UWORD LayoutType;
   UWORD SizeType;
   ULONG Size, MinSize;
   UWORD BorderType;
   LONG BorderSizes[2];
   UWORD GadgetHDelta;
   UWORD GadgetVDelta;
   ULONG AutoSpacing;
   ULONG Flags;
   ULONG Id;
   ULONG IndicatorId;
   ULONG GroupId[2];
   struct TextAttr *TextAttr;
   UBYTE **Text;
   struct ListInfo *ListInfo;
   UBYTE **Labels;
   UWORD MaxLevelLen;
   UWORD LevelPlace;
   struct LayoutItem *Prev, *Next;
   struct LayoutItem *First;
};

struct Layout
{
   UWORD LayoutType;
   struct TextAttr *TextAttr;
   LONG BorderSizes[2];
   UWORD GadgetHDelta;
   UWORD GadgetVDelta;
   ULONG Flags;
};


#endif

