
#ifndef SAVAGE_MACROS_H
#define SAVAGE_MACROS_H

#include <setjmp.h>

/******************************************************************************
** this lets you use simple exception handling with standard ansi-c
** note: never RAISE a value of zero (this would result into an infinite loop)
**
**      TRY
**      {
**           ... RAISE(5); ...
**      }
**      CATCH
**      {
**        switch (exception)
**        {
**          ...
**          case 5:  ...
**          ...
**        }
**      }
**      ENDTRY
*/

#define TRY       { jmp_buf buf; int exception = setjmp(buf); if (!exception) {
#define CATCH     } else {
#define ENDTRY    } }
#define RAISE(e)  longjmp(buf, e)

/******************************************************************************
** this simple macro swaps two long values
**
**      {
**        long x=5, y=9;
**        ..
**        SWAP(&x,&y);
**        ...
**      }
*/

#define SWAP(a,b) { long c=*a; *a=*b; *b=c; }

/******************************************************************************
**
*/

#endif

