
#ifndef SAVAGE_SAVAGEGUI_H
#define SAVAGE_SAVAGEGUI_H

#include <savage/guicontext.h>

/******************************************************************************
 * prototypes for savgui functions
 ******************************************************************************/

APTR savgui_InitRootGClass(struct GUIContext *);
APTR savgui_InitDeafGClass(struct GUIContext *);
APTR savgui_InitHSeperatorGClass(struct GUIContext *);
APTR savgui_InitVSeperatorGClass(struct GUIContext *);
APTR savgui_InitGlueGClass(struct GUIContext *);
APTR savgui_InitStrutGClass(struct GUIContext *);
APTR savgui_InitTextviewGClass(struct GUIContext *);
APTR savgui_InitImageviewGClass(struct GUIContext *);
APTR savgui_InitLabelGClass(struct GUIContext *);
APTR savgui_InitGaugeGClass(struct GUIContext *);
APTR savgui_InitButtonGClass(struct GUIContext *);
APTR savgui_InitTextButtonGClass(struct GUIContext *);
APTR savgui_InitImageButtonGClass(struct GUIContext *);
APTR savgui_InitMXImageButtonGClass(struct GUIContext *);
APTR savgui_InitCheckImageButtonGClass(struct GUIContext *);
APTR savgui_InitFrameGroupGClass(struct GUIContext *);
APTR savgui_InitSocketGroupGClass(struct GUIContext *);
APTR savgui_InitStringGClass(struct GUIContext *);

long            savgui_SetupClasses      (struct GUIContext *);
void            savgui_CloseClasses      (void);
struct Window  *savgui_OpenWindow        (struct TagItem *, APTR);
void            savgui_RefreshGUI        (struct Window *);
void            savgui_SizeGUI           (struct Window *, APTR);
char           *savgui_GetVersionString  (void);
long            savgui_GetIDFromIMsg     (struct IntuiMessage *);
void            savgui_AdaptWindow       (struct Window *, APTR);

ULONG __saveds  savgui_MXHookFunction    (register __a0 struct Hook *, register __a2 APTR);

/******************************************************************************
 * the pointers to the classes and other ressources which must be declared
 * by the caller-program
 ******************************************************************************/

extern APTR savgui_Class_RootGadget;
extern APTR savgui_Class_DeafGadget;
extern APTR savgui_Class_HSeperatorGadget;
extern APTR savgui_Class_VSeperatorGadget;
extern APTR savgui_Class_GlueGadget;
extern APTR savgui_Class_StrutGadget;
extern APTR savgui_Class_TextviewGadget;
extern APTR savgui_Class_ImageviewGadget;
extern APTR savgui_Class_LabelGadget;
extern APTR savgui_Class_GaugeGadget;
extern APTR savgui_Class_ButtonGadget;
extern APTR savgui_Class_TextButtonGadget;
extern APTR savgui_Class_ImageButtonGadget;
extern APTR savgui_Class_MXImageButtonGadget;
extern APTR savgui_Class_CheckImageButtonGadget;
extern APTR savgui_Class_FrameGroupGadget;
extern APTR savgui_Class_SocketGroupGadget;
extern APTR savgui_Class_StringGadget;

extern struct Library *UtilityBase;

/******************************************************************************
 * some macros
 ******************************************************************************/

#define X_GAP             4
#define Y_GAP             4
#define HALF_X_GAP        2
#define HALF_Y_GAP        2
#define NO_LIMIT          (~0)
#define NO_COLOR          (~0)

#define SAVGUIA_Dummy     (TAG_USER + 0x5EAD0000)
#define SAVGUIM_Dummy     (TAG_USER + 0x3AD00000)

/******************************************************************************
 * this is the definition of data, which will be received by the group gadgets
 * for a custom backfilling
 ******************************************************************************/

struct GroupBFHookData
{
  struct RastPort *bfd_RPort;
  UWORD            bfd_Left;
  UWORD            bfd_Top;
  UWORD            bfd_Width;
  UWORD            bfd_Height;
};

/******************************************************************************
 * RootGClass
 ******************************************************************************/

#define SAVGUIM_Root_Dummy                 (SAVGUIM_Dummy + 0x00000100)
#define SAVGUIM_Root_Calculate             (SAVGUIM_Root_Dummy + 1)   /* NEVER USE */
#define SAVGUIM_Root_Relayout              (SAVGUIM_Root_Dummy + 2)   /* NEVER USE */

#define SAVGUIA_Root_Dummy                 (SAVGUIA_Dummy + 0x00000100)
#define SAVGUIA_Root_MinWidth              (SAVGUIA_Root_Dummy + 1)   /* NEVER USE */
#define SAVGUIA_Root_MinHeight             (SAVGUIA_Root_Dummy + 2)   /* NEVER USE */
#define SAVGUIA_Root_MaxWidth              (SAVGUIA_Root_Dummy + 3)   /* NEVER USE */
#define SAVGUIA_Root_MaxHeight             (SAVGUIA_Root_Dummy + 4)   /* NEVER USE */
#define SAVGUIA_Root_MWBPens               (SAVGUIA_Root_Dummy + 5)   /* NEVER USE */
#define SAVGUIA_Root_Visible               (SAVGUIA_Root_Dummy + 6)   /* NEVER USE */
#define SAVGUIA_Root_NeedRefresh           (SAVGUIA_Root_Dummy + 7)   /* NEVER USE */
#define SAVGUIA_Root_Resized               (SAVGUIA_Root_Dummy + 8)   /* NEVER USE */
#define SAVGUIA_Root_ParentGroup           (SAVGUIA_Root_Dummy + 9)   /* NEVER USE */
#define SAVGUIA_Root_GadgetWindow          (SAVGUIA_Root_Dummy + 10)  /* NEVER USE */
#define SAVGUIA_Root_Node                  (SAVGUIA_Root_Dummy + 11)  /* NEVER USE */
#define SAVGUIA_Root_Fixed                 (SAVGUIA_Root_Dummy + 12)
#define SAVGUIA_Root_Alignment             (SAVGUIA_Root_Dummy + 13)

/******************************************************************************
 * GroupGClass
 ******************************************************************************/

#define SAVGUIA_Group_Dummy                (SAVGUIA_Dummy + 0x00000200)
#define SAVGUIA_Group_Child                (SAVGUIA_Group_Dummy + 1)
#define SAVGUIA_Group_ChildList            (SAVGUIA_Group_Dummy + 2)   /* NEVER USE */
#define SAVGUIA_Group_InsetLeft            (SAVGUIA_Group_Dummy + 3)   /* NEVER USE */
#define SAVGUIA_Group_InsetTop             (SAVGUIA_Group_Dummy + 4)   /* NEVER USE */
#define SAVGUIA_Group_InsetRight           (SAVGUIA_Group_Dummy + 5)   /* NEVER USE */
#define SAVGUIA_Group_InsetBottom          (SAVGUIA_Group_Dummy + 6)   /* NEVER USE */
#define SAVGUIA_Group_Text                 (SAVGUIA_Group_Dummy + 7)
#define SAVGUIA_Group_TextStyle            (SAVGUIA_Group_Dummy + 8)
#define SAVGUIA_Group_Frame                (SAVGUIA_Group_Dummy + 9)
#define SAVGUIA_Group_Font                 (SAVGUIA_Group_Dummy + 10)
#define SAVGUIA_Group_BackfillHook         (SAVGUIA_Group_Dummy + 11)
#define SAVGUIA_Group_Broadcast            (SAVGUIA_Group_Dummy + 12)
#define SAVGUIA_Group_Orientation          (SAVGUIA_Group_Dummy + 13)
#define SAVGUIA_Group_Columns              (SAVGUIA_Group_Dummy + 14)
#define SAVGUIA_Group_Rows                 (SAVGUIA_Group_Columns)

/******************************************************************************
 * StrutGClass
 ******************************************************************************/

#define SAVGUIA_Strut_Dummy                (SAVGUIA_Dummy + 0x00000300)
#define SAVGUIA_Strut_Width                (SAVGUIA_Strut_Dummy + 1)
#define SAVGUIA_Strut_Height               (SAVGUIA_Strut_Dummy + 2)

/******************************************************************************
 * GlueGClass
 ******************************************************************************/

#define SAVGUIA_Glue_Dummy                 (SAVGUIA_Dummy + 0x00000400)
#define SAVGUIA_Glue_Orientation           (SAVGUIA_Glue_Dummy + 1)

/******************************************************************************
 * TextviewGClass
 ******************************************************************************/

#define SAVGUIA_Textview_Dummy             (SAVGUIA_Dummy + 0x00000500)
#define SAVGUIA_Textview_Text              (SAVGUIA_Textview_Dummy + 1)
#define SAVGUIA_Textview_TextStyle         (SAVGUIA_Textview_Dummy + 2)
#define SAVGUIA_Textview_Font              (SAVGUIA_Textview_Dummy + 3)
#define SAVGUIA_Textview_Alignment         (SAVGUIA_Textview_Dummy + 4)
#define SAVGUIA_Textview_Frame             (SAVGUIA_Textview_Dummy + 5)

/******************************************************************************
 * ImageviewGClass
 ******************************************************************************/

#define SAVGUIA_Imageview_Dummy            (SAVGUIA_Dummy + 0x00000600)
#define SAVGUIA_Imageview_Image            (SAVGUIA_Imageview_Dummy + 1)

/******************************************************************************
 * LabelGClass
 ******************************************************************************/

#define SAVGUIA_Label_Dummy                (SAVGUIA_Dummy + 0x00000700)
#define SAVGUIA_Label_Underscore           (SAVGUIA_Label_Dummy + 1)
#define SAVGUIA_Label_Text                 (SAVGUIA_Label_Dummy + 2)
#define SAVGUIA_Label_TextStyle            (SAVGUIA_Label_Dummy + 3)
#define SAVGUIA_Label_Font                 (SAVGUIA_Label_Dummy + 4)

/******************************************************************************
 * ButtonGClass
 ******************************************************************************/

#define SAVGUIA_Button_Dummy               (SAVGUIA_Dummy + 0x00000800)
#define SAVGUIA_Button_PressedHook         (SAVGUIA_Button_Dummy + 1)
#define SAVGUIA_Button_ReleasedHook        (SAVGUIA_Button_Dummy + 2)
#define SAVGUIA_Button_Frame               (SAVGUIA_Button_Dummy + 3)

/******************************************************************************
 * TextbuttonGClass
 ******************************************************************************/

#define SAVGUIA_TextButton_Dummy           (SAVGUIA_Dummy + 0x00000900)
#define SAVGUIA_TextButton_Font            (SAVGUIA_TextButton_Dummy + 1)
#define SAVGUIA_TextButton_Text            (SAVGUIA_TextButton_Dummy + 2)
#define SAVGUIA_TextButton_TextStyle       (SAVGUIA_TextButton_Dummy + 3)

/******************************************************************************
 * ImagebuttonGClass
 ******************************************************************************/

#define SAVGUIA_ImageButton_Dummy          (SAVGUIA_Dummy + 0x00000A00)
#define SAVGUIA_ImageButton_Image          (SAVGUIA_ImageButton_Dummy + 1)

/******************************************************************************
 * GaugeGClass
 ******************************************************************************/

#define SAVGUIA_Gauge_Dummy                (SAVGUIA_Dummy + 0x00000B00)
#define SAVGUIA_Gauge_Font                 (SAVGUIA_Gauge_Dummy + 1)
#define SAVGUIA_Gauge_Text                 (SAVGUIA_Gauge_Dummy + 2)
#define SAVGUIA_Gauge_TextStyle            (SAVGUIA_Gauge_Dummy + 3)
#define SAVGUIA_Gauge_Current              (SAVGUIA_Gauge_Dummy + 4)

/******************************************************************************
 * StringGClass
 ******************************************************************************/

#define SAVGUIA_String_Dummy               (SAVGUIA_Dummy + 0x00000C00)
#define SAVGUIA_String_Font                (SAVGUIA_String_Dummy + 1)

/******************************************************************************
 * values for savgui gadget tags (see above)
 ******************************************************************************/

#define SAVGUIV_Orientation_None           (~0)
#define SAVGUIV_Orientation_Vertical       0
#define SAVGUIV_Orientation_Horizontal     1

#define SAVGUIV_Font_Normal                0
#define SAVGUIV_Font_Fixed                 1
#define SAVGUIV_Font_Topaz                 2
#define SAVGUIV_Font_User                  3

#define SAVGUIV_TextStyle_Normal           0
#define SAVGUIV_TextStyle_Bold             1
#define SAVGUIV_TextStyle_Hilight          2
#define SAVGUIV_TextStyle_Shadow           3
#define SAVGUIV_TextStyle_Recessed         4
#define SAVGUIV_TextStyle_Color            5

#define SAVGUIV_Alignment_Left             (1<<0)
#define SAVGUIV_Alignment_HCenter          (1<<1)
#define SAVGUIV_Alignment_Right            (1<<2)
#define SAVGUIV_Alignment_Top              (1<<3)
#define SAVGUIV_Alignment_VCenter          (1<<4)
#define SAVGUIV_Alignment_Bottom           (1<<5)

#define SAVGUIV_Frame_None                 0
#define SAVGUIV_Frame_Recessed             1
#define SAVGUIV_Frame_Raised               2
#define SAVGUIV_Frame_SimpleRecessed       3
#define SAVGUIV_Frame_SimpleRaised         4
#define SAVGUIV_Frame_Button               5
#define SAVGUIV_Frame_PressedButton        6

/******************************************************************************
 * useful macros for creating gui`s
 ******************************************************************************/

#define End                                TAG_DONE, 0)
#define HSeperator                         NewObject(savgui_Class_HSeperatorGadget, NULL
#define VSeperator                         NewObject(savgui_Class_VSeperatorGadget, NULL
#define Glue                               NewObject(savgui_Class_GlueGadget, NULL
#define Strut                              NewObject(savgui_Class_StrutGadget, NULL
#define Textview                           NewObject(savgui_Class_TextviewGadget, NULL
#define Imageview                          NewObject(savgui_Class_ImageviewGadget, NULL
#define Label                              NewObject(savgui_Class_LabelGadget, NULL
#define Gauge                              NewObject(savgui_Class_GaugeGadget, NULL
#define Button                             NewObject(savgui_Class_ButtonGadget, NULL
#define TextButton                         NewObject(savgui_Class_TextButtonGadget, NULL
#define ImageButton                        NewObject(savgui_Class_ImageButtonGadget, NULL
#define MXImageButton                      NewObject(savgui_Class_MXImageButtonGadget, NULL
#define CheckImageButton                   NewObject(savgui_Class_CheckImageButtonGadget, NULL
#define Group                              NewObject(savgui_Class_FrameGroupGadget, NULL
#define HGroup                             NewObject(savgui_Class_FrameGroupGadget, NULL, SAVGUIA_Group_Orientation, SAVGUIV_Orientation_Horizontal, SAVGUIA_Group_Rows, 1
#define VGroup                             NewObject(savgui_Class_FrameGroupGadget, NULL
#define Socket                             NewObject(savgui_Class_SocketGroupGadget, NULL
#define String                             NewObject(savgui_Class_StringGadget, NULL
#define Child                              SAVGUIA_Group_Child

#endif
