
#include "includes.h"

struct Library    *UtilityBase, *GadtoolsBase;
struct Window     *win;
struct GUIContext *guicontext;
struct Gadget     *gad, *button, *addchild1, *addchild2, *socket, *hidebutton;

/****************************************************************************************/

void main(void)
{
  struct IntuiMessage *imsg;
  BOOL wait = TRUE;

  //printf("%s\n", savgui_GetVersionString());

  if (GadtoolsBase = OpenLibrary("gadtools.library", 37))
  {
    if (UtilityBase = OpenLibrary("utility.library", 37))
    {
      if (guicontext = sav_GetGUIContext("Workbench"))
      {
        if (savgui_SetupClasses(guicontext))
        {
          APTR rootgad = VGroup,
                           SAVGUIA_Root_MWBPens, TRUE,

                           Child, Textview,
                             SAVGUIA_Textview_Text, "Welcome to the cool SavGUI :=)",
                           End,

                           Child, Glue,
                           End,

                           Child, HGroup,
                             SAVGUIA_Group_Frame, SAVGUIV_Frame_Recessed,
                             SAVGUIA_Group_Text, " Select mode ",

                             Child, Glue,
                               SAVGUIA_Glue_Orientation, SAVGUIV_Orientation_Horizontal,
                             End,
                             Child, Group,
                               SAVGUIA_Group_Orientation, SAVGUIV_Orientation_Horizontal,
                               SAVGUIA_Group_Rows, 3,
                               Child, MXImageButton,
                                 SAVGUIA_Button_Frame, SAVGUIV_Frame_None,
                                 GA_ToggleSelect, TRUE,
                               End,
                               Child, Label,
                                 SAVGUIA_Label_Text, "Novice",
                                 SAVGUIA_Root_Alignment, SAVGUIV_Alignment_Left,
                               End,
                               Child, MXImageButton,
                                 SAVGUIA_Button_Frame, SAVGUIV_Frame_None,
                                 GA_ToggleSelect, TRUE,
                               End,
                               Child, Label,
                                 SAVGUIA_Label_Text, "Average",
                                 SAVGUIA_Root_Alignment, SAVGUIV_Alignment_Left,
                               End,
                               Child, MXImageButton,
                                 SAVGUIA_Button_Frame, SAVGUIV_Frame_None,
                                 GA_ToggleSelect, TRUE,
                               End,
                               Child, Label,
                                 SAVGUIA_Label_Text, "Expert",
                                 SAVGUIA_Root_Alignment, SAVGUIV_Alignment_Left,
                               End,
                             End,
                             Child, Glue,
                               SAVGUIA_Glue_Orientation, SAVGUIV_Orientation_Horizontal,
                             End,
                           End,
                           Child, Glue,
                           End,

                           // eine waagerechte trennlinie
                           Child, HSeperator,
                           End,

                           // jetzt die gruppe von 4 buttons
                           Child, Group,
                             SAVGUIA_Group_Orientation, SAVGUIV_Orientation_Horizontal,
                             SAVGUIA_Group_Rows, 2,
                             Child, TextButton,
                               GA_ID, 1,
                               SAVGUIA_TextButton_Text, "Proceed",
                               SAVGUIA_TextButton_TextStyle, SAVGUIV_TextStyle_Bold,
                             End,
                             Child, TextButton,
                               GA_ID, 2,
                               SAVGUIA_TextButton_Text, "About",
                             End,
                             Child, TextButton,
                               GA_ID, 3,
                               SAVGUIA_TextButton_Text, "Cancel",
                             End,
                             Child, TextButton,
                               GA_ID, 4,
                               SAVGUIA_TextButton_Text, "Help",
                             End,
                           End,
                         End;

          if (rootgad)
          {
            struct TagItem wintags[] = { { WA_Left,        400 },
                                         { WA_Top,         200 },
                                         { WA_InnerWidth,  ((struct Gadget *) rootgad) -> Width + X_GAP + X_GAP },
                                         { WA_InnerHeight, ((struct Gadget *) rootgad) -> Height + Y_GAP + Y_GAP },
                                         { WA_Flags,       WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|
                                                           WFLG_SIZEGADGET|WFLG_SIZEBBOTTOM },
                                         { WA_IDCMP,       IDCMP_INACTIVEWINDOW|IDCMP_CLOSEWINDOW|IDCMP_NEWSIZE|IDCMP_IDCMPUPDATE },
                                         { WA_PubScreen,   (ULONG) guicontext -> gc_Screen },
                                         { WA_MaxWidth,    -1 },
                                         { WA_MaxHeight,   -1 },
                                         { TAG_DONE,       0 } };

            if (win = savgui_OpenWindow((struct TagItem *) &wintags, rootgad))
            {
              BOOL add = TRUE;

              do
              {
                WaitPort(win -> UserPort);
                imsg = (struct IntuiMessage *) GetMsg(win -> UserPort);

                switch (imsg -> Class)
                {
                  case IDCMP_CLOSEWINDOW:    { wait = FALSE; break }
                  case IDCMP_IDCMPUPDATE:    { printf("%ld\n", savgui_GetIDFromIMsg(imsg)); break }
                  case IDCMP_NEWSIZE:        { savgui_SizeGUI(win, rootgad); break }
                }

                ReplyMsg((struct Message *) imsg);
              }
              while (wait);

              RemoveGList(win, rootgad, -1);
              CloseWindow(win);
            }

            DisposeObject(rootgad);
          }
        }

        savgui_CloseClasses();
        sav_FreeGUIContext(guicontext);
      }

      CloseLibrary(UtilityBase);
    }

    CloseLibrary(GadtoolsBase);
  }
}

