/*
**  ExtFrameIClass - (c) 1999 Matteo Cavalleri
**
**
**  Please read the documentation for
**  usage and license of this source.
**
**  TODO
**
**        - Neither Mungwall nor Wipeout seem to like the demo program.
**          I had a similar problem in the past and I solved it. Now
**          I've really no clue on what may be the problem, since even
**          this time they does not report anything. My computer
**          just lock up... :(
**
**        - window's too high! i think it doesn't fit on a non-laced
**          pal screen :)
**
**  HISTORY
**
**    0.6 - updated to support new class version
**        - bigger palette gadgets for my new 16 bit screen :)
**        - put the pen tags inside comment to test the new
**          frame capability to get the default pens from
**          the drawinfo structure.
**
**    0.5 - updated to support new class version
**        - added three new palette gadgets
**        - maybe i should change the layout of the
**          gadgets. i think the window is too big
**          for a non-laced screen...
**        - forgot to update $VER: string.
**
**    0.4 - fixed a lot of stupid bugs :(
**
**    0.3 - rewritten almost entirely from scratch
**
**    0.2 - added palette gadgets to change frame colours.
**        - added cycle gadgets to change frame types.
**
**    0.1 - First version
*/

/* /// "Include" */

/* Avoid including this header file because of */
/* conflicting definitions in BoopsiStubs.h    */
#define  CLIB_ALIB_PROTOS_H

#include <dos/dos.h>
#include <intuition/intuition.h>
#include <intuition/screens.h>
#include <intuition/classes.h>
#include <intuition/gadgetclass.h>
#include <intuition/imageclass.h>
#include <utility/tagitem.h>
#include <libraries/gadtools.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/utility.h>
#include <proto/gadtools.h>

#include <stdio.h>

#include "BoopsiStubs.h"
#include "images/ExtFrameIClass.h"

/* /// */
/* /// "Global" */

static UBYTE versiontag[] = "$VER: ExtFrameIDemo 0.6 (30.3.99) by Matteo Cavalleri";

/* this array contain the frames name */
STRPTR names[] =
{
    "DEFAULT",
    "BUTTON",
    "RIDGE",
    "ICONDROPBOX",
    "FLAT",
    "XEN",
    "BUTTON2",
    "RIDGE2",
    NULL
};

/* this array will let us cycle through the various frame tupes  */
ULONG frames[] =
{
    FRAME_DEFAULT,
    FRAME_BUTTON,
    FRAME_RIDGE,
    FRAME_ICONDROPBOX,
    FRAME_FLAT,
    FRAME_XEN,
    FRAME_BUTTON2,
    FRAME_RIDGE2
};

/* these are the palette gadget width and height */
#define GADGET_WIDTH            197
#define GADGET_HEIGHT           60

#define ID_FRAMETYPE            1
#define ID_RECESSED             2
#define ID_SHINEPEN             3
#define ID_SHADOWPEN            4
#define ID_HALFSHINEPEN         5
#define ID_HALFSHADOWPEN        6
#define ID_BACKGROUNDPEN        7
#define ID_SELBACKGROUNDPEN     8

struct Screen   *sptr = NULL;
struct Window   *wptr = NULL;
struct Gadget   *glist = NULL;
struct Gadget   *button = NULL;
struct Image    *frame = NULL;
APTR             vinfo = NULL;
struct DrawInfo *dri = NULL;

ULONG  width, height;

#ifdef PRIVATE_EXTFRAMEICLASS
    Class *efclass = NULL;
#else
    struct ClassLibrary *ExtFrameBase = NULL;
#endif

struct DosLibrary       *DOSBase = NULL;
struct IntuitionBase    *IntuitionBase = NULL;
struct UtilityBase      *UtilityBase = NULL;
struct Library          *GadToolsBase = NULL;

/* /// */
/* /// "Prototyping" */

int main(void);
BOOL open_window(void);
BOOL create_gadgets(void);
void dispose_gadgets(void);
void wait_selection(void);

/* /// */

/* /// "main" */

int main(void)
{
    LONG retval = RETURN_FAIL;
    BOOL result = FALSE;

    DOSBase = (struct DosLibrary *)OpenLibrary("dos.library", 37);
    if(DOSBase != NULL)
    {
        IntuitionBase = (struct IntuitionBase *)OpenLibrary ("intuition.library", 0);
        if(IntuitionBase != NULL)
        {
            UtilityBase = (struct UtilityBase *)OpenLibrary("utility.library", 0);
            if(UtilityBase != NULL)
            {
                GadToolsBase = OpenLibrary("gadtools.library", 0);
                if(GadToolsBase != NULL)
                {
#ifndef PRIVATE_EXTFRAMEICLASS
                    ExtFrameBase = OpenLibrary("images/extframe.image", 0);
                    if(ExtFrameBase != NULL)
#else
                    efclass = makeExtFrameIClass();
                    if(efclass != NULL)
#endif
                    {
                        result = open_window();
                        if(result == TRUE)
                        {
                            wait_selection();
                            retval = RETURN_OK;

                            CloseWindow(wptr);
                            RemoveGList(wptr, glist, -1);
                            RemoveGadget(wptr, button);
                            /* dispose the gadgets */
                            dispose_gadgets();
                        }

#ifndef PRIVATE_EXTFRAMEICLASS
                        CloseLibrary((struct Library *)ExtFrameBase);
#else
                        freeExtFrameIClass(efclass);
#endif
                    }
                    CloseLibrary(GadToolsBase);
                }
                CloseLibrary((struct Library *)UtilityBase);
            }
            CloseLibrary((struct Library *)IntuitionBase);
        }
        CloseLibrary((struct Library *)DOSBase);
    }
    return retval;
}

/* /// */
/* /// "open_window" */

BOOL open_window(void)
{
    BOOL result = FALSE;

    /* get the screen address */
    sptr = LockPubScreen(NULL);
    if(sptr != NULL)
    {
        /* create the gadgets */
        result = create_gadgets();
        if(result == TRUE)
        {
            /* add the borders size */
            width  += sptr->WBorLeft + 4 + sptr->WBorRight;
            height += (sptr->WBorTop + sptr->Font->ta_YSize + 1) + 4 + sptr->WBorBottom;

            /* open the window */
            wptr = OpenWindowTags(NULL,
                        WA_Top,         (sptr->Height - height) / 2,
                        WA_Left,        (sptr->Width - width) / 2,
                        WA_Width,       width,
                        WA_Height,      height,
                        WA_PubScreen,   (ULONG)sptr,
                        WA_AutoAdjust,  TRUE,
                        WA_IDCMP,       IDCMP_CLOSEWINDOW |
                                        IDCMP_GADGETUP,
                        WA_Flags,       WFLG_DRAGBAR |
                                        WFLG_DEPTHGADGET |
                                        WFLG_CLOSEGADGET |
                                        WFLG_SIMPLE_REFRESH |
                                        WFLG_NOCAREREFRESH,
                        WA_ScreenTitle, (ULONG)versiontag + 6,
                        WA_Title,       (ULONG)"ExtFrameIDemo",
                        TAG_DONE);
            if(wptr != NULL)
            {
                UnlockPubScreen(NULL, sptr);

                /* add the button to the window */
                AddGadget(wptr, button, -1);
                /* add all the other gadgets */
                AddGList(wptr, glist, -1, -1, NULL);
                /* display the gadgets */
                RefreshGList(button, wptr, NULL, -1);
                GT_RefreshWindow(wptr, NULL);

                return TRUE;
            }
            dispose_gadgets();
        }
        UnlockPubScreen(NULL, sptr);
    }
    return FALSE;
}

/* /// */
/* /// "create_gadgets" */

BOOL create_gadgets(void)
{
    struct Gadget *gad;

    /* this is the definition */
    /* for the cycle gadget   */
    struct NewGadget cyc1 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,         /* ng_LeftEdge   */
        NULL,                       /* ng_TopEdge    */
        GADGET_WIDTH,               /* ng_Width      */
        sptr->Font->ta_YSize + 4,   /* ng_Height     */
        "Frame Type",               /* ng_GadgetText */
        sptr->Font,                 /* ng_TextAttr   */
        NULL,                       /* ng_GadgetID   */
        PLACETEXT_ABOVE,            /* ng_Flags      */
        NULL,                       /* ng_VisualInfo */
        (APTR)ID_FRAMETYPE          /* ng_UserData   */
    };
    /* this switch from normal */
    /* and recessed version    */
    struct NewGadget chk1 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,         /* ng_LeftEdge   */
        NULL,                       /* ng_TopEdge    */
        GADGET_WIDTH,               /* ng_Width      */
        sptr->Font->ta_YSize + 4,   /* ng_Height     */
        "Recessed",                 /* ng_GadgetText */
        sptr->Font,                 /* ng_TextAttr   */
        NULL,                       /* ng_GadgetID   */
        PLACETEXT_RIGHT,            /* ng_Flags      */
        NULL,                       /* ng_VisualInfo */
        (APTR)ID_RECESSED           /* ng_UserData   */
    };
    /* these are the definition */
    /* for the palette gadgets  */
    struct NewGadget pal1 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,
        NULL,
        GADGET_WIDTH,
        GADGET_HEIGHT,
        "Shine pen",
        sptr->Font,
        NULL,
        PLACETEXT_ABOVE,
        NULL,
        (APTR)ID_SHINEPEN
    };
    struct NewGadget pal2 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,
        NULL,
        GADGET_WIDTH,
        GADGET_HEIGHT,
        "Shadow pen",
        sptr->Font,
        NULL,
        PLACETEXT_ABOVE,
        NULL,
        (APTR)ID_SHADOWPEN
    };
    struct NewGadget pal3 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,
        NULL,
        GADGET_WIDTH,
        GADGET_HEIGHT,
        "HalfShine pen",
        sptr->Font,
        NULL,
        PLACETEXT_ABOVE,
        NULL,
        (APTR)ID_HALFSHINEPEN
    };
    struct NewGadget pal4 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,
        NULL,
        GADGET_WIDTH,
        GADGET_HEIGHT,
        "HalfShadow pen",
        sptr->Font,
        NULL,
        PLACETEXT_ABOVE,
        NULL,
        (APTR)ID_HALFSHADOWPEN
    };
    struct NewGadget pal5 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,
        NULL,
        GADGET_WIDTH,
        GADGET_HEIGHT,
        "Background pen",
        sptr->Font,
        NULL,
        PLACETEXT_ABOVE,
        NULL,
        (APTR)ID_BACKGROUNDPEN
    };
    struct NewGadget pal6 = (struct NewGadget)
    {
        sptr->WBorLeft + 2,
        NULL,
        GADGET_WIDTH,
        GADGET_HEIGHT,
        "Sel. Background pen",
        sptr->Font,
        NULL,
        PLACETEXT_ABOVE,
        NULL,
        (APTR)ID_SELBACKGROUNDPEN
    };

    /* GetScreenDrawInfo() never fails */
    dri = GetScreenDrawInfo(sptr);

    /* GetVisualInfo() not... */
    vinfo = GetVisualInfoA(sptr, NULL);
    if(vinfo != NULL)
    {
#ifdef PRIVATE_EXTFRAMEICLASS
        frame = (struct Image *)NewObject(efclass, NULL,
/*
                                IA_PenBackground, dri->dri_Pens[BACKGROUNDPEN],
                                IA_PenSelBackground, dri->dri_Pens[FILLPEN],
                                IA_PenShine, dri->dri_Pens[SHINEPEN],
                                IA_PenShadow, dri->dri_Pens[SHADOWPEN],
                                IA_PenHalfShine, dri->dri_Pens[SHINEPEN],
                                IA_PenHalfShadow, dri->dri_Pens[SHADOWPEN],
*/
                                IA_EdgesOnly, FALSE,
                                TAG_DONE);
#else
        frame = (struct Image *)NewObject(NULL, EXTFRAMEICLASS,
/*
                                IA_PenBackground, dri->dri_Pens[BACKGROUNDPEN],
                                IA_PenSelBackground, dri->dri_Pens[FILLPEN],
                                IA_PenShine, dri->dri_Pens[SHINEPEN],
                                IA_PenShadow, dri->dri_Pens[SHADOWPEN],
                                IA_PenHalfShine, dri->dri_Pens[SHINEPEN],
                                IA_PenHalfShadow, dri->dri_Pens[SHADOWPEN],
*/
                                IA_EdgesOnly, FALSE,
                                TAG_DONE);
#endif
        if(frame != NULL)
        {
            /* frbuttonclass gadgets set their dimension accordingly to their */
            /* content, so we don't need to specify GA_Width and GA_Height    */
            button = (struct Gadget *)NewObject(NULL, FRBUTTONCLASS,
                                      GA_Left, 0,
                                      GA_Top, sptr->WBorTop + sptr->Font->ta_YSize + 3,
                                      GA_DrawInfo, (ULONG)dri,
                                      GA_Text, (ULONG)"Click Me!",
                                      GA_Image, (ULONG)frame,
                                      TAG_DONE);
            if(button != NULL)
            {
                /* calculate gadgets top edge */
                cyc1.ng_TopEdge = button->TopEdge + button->Height + sptr->Font->ta_YSize + 8 + 8;
                chk1.ng_TopEdge = cyc1.ng_TopEdge + cyc1.ng_Height + sptr->Font->ta_YSize + 8;
                pal1.ng_TopEdge = chk1.ng_TopEdge + chk1.ng_Height + sptr->Font->ta_YSize + 8;
                pal2.ng_TopEdge = pal1.ng_TopEdge + pal1.ng_Height + sptr->Font->ta_YSize + 8;
                pal3.ng_TopEdge = pal2.ng_TopEdge + pal2.ng_Height + sptr->Font->ta_YSize + 8;
                pal4.ng_TopEdge = pal3.ng_TopEdge + pal3.ng_Height + sptr->Font->ta_YSize + 8;
                pal5.ng_TopEdge = pal4.ng_TopEdge + pal4.ng_Height + sptr->Font->ta_YSize + 8;
                pal6.ng_TopEdge = pal5.ng_TopEdge + pal5.ng_Height + sptr->Font->ta_YSize + 8;
                /* set gadgets' visualinfo */
                cyc1.ng_VisualInfo = chk1.ng_VisualInfo = vinfo;
                pal1.ng_VisualInfo = pal2.ng_VisualInfo = pal3.ng_VisualInfo = vinfo;
                pal4.ng_VisualInfo = pal5.ng_VisualInfo = pal6.ng_VisualInfo = vinfo;

                /* create the gadgets context */
                gad = CreateContext(&glist);

                /* this edit the frame type */
                gad = CreateGadget(CYCLE_KIND, gad, (struct NewGadget *)&cyc1,
                                   GTCY_Labels, (ULONG)names,
                                   GTCY_Active, 0,
                                   TAG_DONE);
                /* this edit the recessed attribute */
                gad = CreateGadget(CHECKBOX_KIND, gad, (struct NewGadget *)&chk1,
                                   GTCB_Checked, FALSE,
                                   TAG_DONE);
                /* this edit the shine pen */
                gad = CreateGadget(PALETTE_KIND, gad, (struct NewGadget *)&pal1,
                                   GTPA_Depth, sptr->BitMap.Depth,
                                   GTPA_Color, dri->dri_Pens[SHINEPEN],
                                   GTPA_IndicatorWidth, 10,
                                   TAG_DONE);
                /* this edit the shadow pen */
                gad = CreateGadget(PALETTE_KIND, gad, (struct NewGadget *)&pal2,
                                   GTPA_Depth, sptr->BitMap.Depth,
                                   GTPA_Color, dri->dri_Pens[SHADOWPEN],
                                   GTPA_IndicatorWidth, 10,
                                   TAG_DONE);
                /* this edit the halfshine pen */
                gad = CreateGadget(PALETTE_KIND, gad, (struct NewGadget *)&pal3,
                                   GTPA_Depth, sptr->BitMap.Depth,
                                   GTPA_Color, dri->dri_Pens[SHINEPEN],
                                   GTPA_IndicatorWidth, 10,
                                   TAG_DONE);
                /* this edit the halfshadow pen */
                gad = CreateGadget(PALETTE_KIND, gad, (struct NewGadget *)&pal4,
                                   GTPA_Depth, sptr->BitMap.Depth,
                                   GTPA_Color, dri->dri_Pens[SHADOWPEN],
                                   GTPA_IndicatorWidth, 10,
                                   TAG_DONE);
                /* this edit the background pen */
                gad = CreateGadget(PALETTE_KIND, gad, (struct NewGadget *)&pal5,
                                   GTPA_Depth, sptr->BitMap.Depth,
                                   GTPA_Color, dri->dri_Pens[BACKGROUNDPEN],
                                   GTPA_IndicatorWidth, 10,
                                   TAG_DONE);
                /* this edit the selected background pen */
                gad = CreateGadget(PALETTE_KIND, gad, (struct NewGadget *)&pal6,
                                   GTPA_Depth, sptr->BitMap.Depth,
                                   GTPA_Color, dri->dri_Pens[FILLPEN],
                                   GTPA_IndicatorWidth, 10,
                                   TAG_DONE);
                if(gad != NULL)
                {
                    /* change the button leftedge so that */
                    /* it is centered in the window       */

                    /* NB we suppose that button width is smaller than other */
                    /* gadgets width. this is not a good thing to do... :-)  */
                    button->LeftEdge = ((GADGET_WIDTH - button->Width) / 2) + 2;

                    /* NOTE: the button and all the other gadgets   */
                    /* are not linked! so we must add to the window */
                    /* the button AND all the other gadgets         */

                    /* set the total space occupied by our gadgets */
                    width = GADGET_WIDTH;
                    height = pal6.ng_TopEdge + pal6.ng_Height - button->TopEdge;

                    return TRUE;
                }
            }
        }
    }
    /* free everything */
    dispose_gadgets();

    return FALSE;
}

/* /// */
/* /// "dispose_gadgets" */

void dispose_gadgets(void)
{
    /* all this functions accept NULL parameters */
    FreeGadgets(glist);
    DisposeObject((Object *)button);
    DisposeObject((Object *)frame);
    FreeVisualInfo(vinfo);
    FreeScreenDrawInfo(sptr, dri);
}

/* /// */
/* /// "wait_selection" */

void wait_selection(void)
{
    struct TagItem tags[2];
    ULONG  sigmask, sigrcvd;
    BOOL   quit = FALSE;
    struct IntuiMessage *imsg;
    struct Gadget *iaddr;
    ULONG  iclass, inum;

    /* end the taglist */
    tags[1].ti_Tag = TAG_DONE;

    /* pre-calculate the signal mask for Wait() */
    sigmask = (1 << wptr->UserPort->mp_SigBit);

    while(quit == FALSE)
    {
        /* wait user input */
        sigrcvd = Wait(sigmask | SIGBREAKF_CTRL_C);

        /* break signal? */
        if(sigrcvd & SIGBREAKF_CTRL_C) quit = TRUE;

        /* IDCMP message? */
        if(sigrcvd & sigmask)
        {
            while(imsg = GT_GetIMsg(wptr->UserPort))
            {
                iclass = imsg->Class;
                iaddr = (struct Gadget *)imsg->IAddress;
                inum = imsg->Code;
                GT_ReplyIMsg(imsg);

                switch(iclass)
                {
                    case IDCMP_CLOSEWINDOW:
                        quit = TRUE;
                        break;
                    case IDCMP_GADGETUP:
                        /* look which gadget was selected */
                        switch((ULONG)iaddr->UserData)
                        {
                            case ID_FRAMETYPE:
                                tags[0].ti_Tag = IA_FrameType;
                                tags[0].ti_Data = frames[inum];
                                break;
                            case ID_RECESSED:
                                tags[0].ti_Tag = IA_Recessed;
                                if(iaddr->Flags & SELECTED)
                                    tags[0].ti_Data = TRUE;
                                else
                                    tags[0].ti_Data = FALSE;
                                break;
                            case ID_SHINEPEN:
                                /* the user selected pen 'inum' */
                                tags[0].ti_Tag = IA_PenShine;
                                tags[0].ti_Data = inum;
                                break;
                            case ID_SHADOWPEN:
                                tags[0].ti_Tag = IA_PenShadow;
                                tags[0].ti_Data = inum;
                                break;
                            case ID_HALFSHINEPEN:
                                tags[0].ti_Tag = IA_PenHalfShine;
                                tags[0].ti_Data = inum;
                                break;
                            case ID_HALFSHADOWPEN:
                                tags[0].ti_Tag = IA_PenHalfShadow;
                                tags[0].ti_Data = inum;
                                break;
                            case ID_BACKGROUNDPEN:
                                tags[0].ti_Tag = IA_PenBackground;
                                tags[0].ti_Data = inum;
                                break;
                            case ID_SELBACKGROUNDPEN:
                                tags[0].ti_Tag = IA_PenSelBackground;
                                tags[0].ti_Data = inum;
                                break;
                        }
                        /* tell our frame to change its aspect */
                        DoMethod((Object *)frame, OM_SET, (ULONG)&tags, NULL);
                        /* redraw the gadget and its frame */
                        RefreshGList(button, wptr, NULL, 1);
                        break;
                }
            }
        }
    }
}

/* /// */

