#ifndef LABELTEXTICLASS_H
#define LABELTEXTICLASS_H
/*
**  LabelTextIClass - (c) 1999 Matteo Cavalleri
**  
**
**  Please read the documentation for
**  usage and license of this source.
*/

/* /// "Global" */

/* label types */
#define LTA_TYPE_NORMAL         0   /* simple text with the shadow pen   */
#define LTA_TYPE_HILIGHT        1   /* simple text with the shine pen    */
#define LTA_TYPE_3D             2   /* 3d text with shadow and shine pen */

/* maximum number of renderings defined, never to
** be used outside the class (it must be equal
** to the last defined value, not bigger)
*/
#define LABELTEXT_MAXTYPE        2

/* label positions */
#define LTA_POSITION_INSIDE     0
#define LTA_POSITION_ABOVE      1
#define LTA_POSITION_BELOW      2
#define LTA_POSITION_LEFT       3
#define LTA_POSITION_RIGHT      4

/* maximum number of position defined, never to
** be used outside the class (it must be equal
** to the last defined value, not bigger)
*/
#define LABELTEXT_MAXPOS         4

/* label alignment */
#define LTA_ALIGN_CENTER        0
#define LTA_ALIGN_TOP           1
#define LTA_ALIGN_BOTTOM        2
#define LTA_ALIGN_LEFT          3
#define LTA_ALIGN_RIGHT         4

/* maximum number of position defined, never to
** be used outside the class (it must be equal
** to the last defined value, not bigger)
*/
#define LABELTEXT_MAXALIGN       4

/* attributes for this class */
#define LTA_Label               (IA_Dummy + 0x71)
#define LTA_LabelType           (IA_Dummy + 0x72)
#define LTA_Distance            (IA_Dummy + 0x73)
#define LTA_Position            (IA_Dummy + 0x74)
#define LTA_Align               (IA_Dummy + 0x75)
#define LTA_Font                (IA_Dummy + 0x76)
#define LTA_PenBackground       (IA_Dummy + 0x77)
#define LTA_PenShine            (IA_Dummy + 0x78)
#define LTA_PenShadow           (IA_Dummy + 0x79)
#define LTA_PenHalfShine        (IA_Dummy + 0x7a)
#define LTA_PenHalfShadow       (IA_Dummy + 0x7b)

#ifndef PRIVATE_LABELTEXTICLASS
    #define LABELTEXTICLASS          "labeltexticlass"
    #ifndef CLASSLIBRARY_H
        #include "common/ClassLibrary.h"
    #endif
#else
    Class *makeLabelTextIClass(void);

    #define freeLabelTextIClass(cl) FreeClass(cl)
#endif

/* /// */

#endif

